Users

Update a user by id

Since 7.1.0
PUT/users/{userId}

Change the fields sent and leave the rest. Besides the ext-relation update's fields, extRelationId and relationStrs set, change or remove the links a billing system addresses the user by. An administrator cannot be changed here and admin is never accepted.

Request

Authorization
Provide your bearer token in the Authorization header when making requests to protected resources.
Example: Authorization: Bearer ********************
Path Params#
userIdinteger#required

The user's id as shown in VirtFusion.

Example: 3
Body Paramsapplication/json#

Fields to change. Omitted fields are left as they are.

object
namestring#

Full name of the user, at least 3 characters.

emailstring#

Email address, unique among users.

enabledboolean#

false suspends the account.

extRelationIdinteger#nullable

The external relation ID to link the user by, unique among users; null removes it.

relationStrsarray[string]#nullable

The whole list of relation strings to link the user by, each 2 to 200 letters, digits, dashes or underscores and unique among users. The list replaces the user's current one; an empty list or null removes them all.

selfServiceinteger#

Self-service level for the user.

ValueMeaning
0Disabled
1Hourly
2Resource packs
3Hourly and resource packs
selfServiceHourlyCreditboolean#

Enable or disable credit balance billing for hourly self service.

selfServiceHourlyGroupProfilesarray[integer]#

Self service hourly group profile ids.

selfServiceResourceGroupProfilesarray[integer]#

Self service resource group profile ids.

selfServiceHourlyResourcePackinteger#nullable

ID of an hourly self service resource pack, null for none.

Example
{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}

Request Code Samples

curl --location --request PUT 'https://cp.domain.com/api/v1/users/3' \
--header 'Authorization: Bearer <token>' \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--data-raw '{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}'
wget --quiet --output-document=- \
  --method=PUT \
  --header='Authorization: Bearer <token>' \
  --header='Accept: application/json' \
  --header='Content-Type: application/json' \
  --body-data='{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}' \
  'https://cp.domain.com/api/v1/users/3'
http PUT 'https://cp.domain.com/api/v1/users/3' \
  'Authorization: Bearer <token>' \
  'Accept: application/json' \
  'Content-Type: application/json' <<< '{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}'
const response = await fetch("https://cp.domain.com/api/v1/users/3", {
    method: "PUT",
    headers: {
        "Authorization": "Bearer <token>",
        "Accept": "application/json",
        "Content-Type": "application/json",
    },
    body: JSON.stringify({
        "name": "jon Doe",
        "extRelationId": 1,
        "relationStrs": [
            "acct-1",
            "acct-1-legacy"
        ],
        "enabled": true
    }),
});

const data = await response.json();
console.log(response.status, data);
import axios from "axios";

const response = await axios({
    method: "put",
    url: "https://cp.domain.com/api/v1/users/3",
    headers: {
        "Authorization": "Bearer <token>",
        "Accept": "application/json",
        "Content-Type": "application/json",
    },
    data: {
        "name": "jon Doe",
        "extRelationId": 1,
        "relationStrs": [
            "acct-1",
            "acct-1-legacy"
        ],
        "enabled": true
    },
});

console.log(response.status, response.data);
const https = require("https");

const payload = JSON.stringify({
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
});

const req = https.request({
    hostname: "cp.domain.com",
    path: "/api/v1/users/3",
    method: "PUT",
    headers: {
        "Authorization": "Bearer <token>",
        "Accept": "application/json",
        "Content-Type": "application/json",
        "Content-Length": Buffer.byteLength(payload),
    },
}, (res) => {
    let data = "";
    res.on("data", (chunk) => (data += chunk));
    res.on("end", () => console.log(res.statusCode, JSON.parse(data)));
});

req.on("error", (err) => console.error(err));
req.write(payload);
req.end();
import requests

url = "https://cp.domain.com/api/v1/users/3"
headers = {
    "Authorization": "Bearer <token>",
    "Accept": "application/json",
    "Content-Type": "application/json",
}
payload = {
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy",
    ],
    "enabled": True,
}

response = requests.request("PUT", url, headers=headers, json=payload)

print(response.status_code)
print(response.json())
import http.client
import json

conn = http.client.HTTPSConnection("cp.domain.com")
headers = {
    "Authorization": "Bearer <token>",
    "Accept": "application/json",
    "Content-Type": "application/json",
}
payload = json.dumps({
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy",
    ],
    "enabled": True,
})

conn.request("PUT", "/api/v1/users/3", payload, headers)
response = conn.getresponse()

print(response.status)
print(json.loads(response.read()))
<?php

$curl = curl_init();

curl_setopt_array($curl, array(
    CURLOPT_URL => 'https://cp.domain.com/api/v1/users/3',
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => '',
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 0,
    CURLOPT_FOLLOWLOCATION => true,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => 'PUT',
    CURLOPT_POSTFIELDS => json_encode([
        'name' => 'jon Doe',
        'extRelationId' => 1,
        'relationStrs' => [
            'acct-1',
            'acct-1-legacy',
        ],
        'enabled' => true,
    ]),
    CURLOPT_HTTPHEADER => array(
        'Authorization: Bearer <token>',
        'Accept: application/json',
        'Content-Type: application/json'
    ),
));

$response = curl_exec($curl);
curl_close($curl);

echo $response;
<?php

require 'vendor/autoload.php';

use GuzzleHttp\Client;

$client = new Client();

$response = $client->request('PUT', 'https://cp.domain.com/api/v1/users/3', [
    'headers' => [
        'Authorization' => 'Bearer <token>',
        'Accept' => 'application/json',
    ],
    'json' => [
        'name' => 'jon Doe',
        'extRelationId' => 1,
        'relationStrs' => [
            'acct-1',
            'acct-1-legacy',
        ],
        'enabled' => true,
    ],
]);

echo $response->getStatusCode() . "\n";
echo $response->getBody();
package main

import (
    "fmt"
    "io"
    "net/http"
    "strings"
)

func main() {
    url := "https://cp.domain.com/api/v1/users/3"
    payload := strings.NewReader(`{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}`)
    req, _ := http.NewRequest("PUT", url, payload)
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Accept", "application/json")
    req.Header.Add("Content-Type", "application/json")

    res, err := http.DefaultClient.Do(req)
    if err != nil {
        panic(err)
    }
    defer res.Body.Close()

    body, _ := io.ReadAll(res.Body)
    fmt.Println(res.StatusCode, string(body))
}
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

public class Main {
    public static void main(String[] args) throws Exception {
        HttpClient client = HttpClient.newHttpClient();

        HttpRequest request = HttpRequest.newBuilder()
            .uri(URI.create("https://cp.domain.com/api/v1/users/3"))
            .header("Authorization", "Bearer <token>")
            .header("Accept", "application/json")
            .header("Content-Type", "application/json")
            .method("PUT", HttpRequest.BodyPublishers.ofString("{\"name\":\"jon Doe\",\"extRelationId\":1,\"relationStrs\":[\"acct-1\",\"acct-1-legacy\"],\"enabled\":true}"))
            .build();

        HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
        System.out.println(response.statusCode());
        System.out.println(response.body());
    }
}
import okhttp3.*;

public class Main {
    public static void main(String[] args) throws Exception {
        OkHttpClient client = new OkHttpClient();

        MediaType json = MediaType.get("application/json");
        RequestBody body = RequestBody.create("{\"name\":\"jon Doe\",\"extRelationId\":1,\"relationStrs\":[\"acct-1\",\"acct-1-legacy\"],\"enabled\":true}", json);

        Request request = new Request.Builder()
            .url("https://cp.domain.com/api/v1/users/3")
            .method("PUT", body)
            .addHeader("Authorization", "Bearer <token>")
            .addHeader("Accept", "application/json")
            .build();

        try (Response response = client.newCall(request).execute()) {
            System.out.println(response.code());
            System.out.println(response.body().string());
        }
    }
}
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;

var client = new HttpClient();
var request = new HttpRequestMessage(new HttpMethod("PUT"), "https://cp.domain.com/api/v1/users/3");
request.Headers.Authorization = new AuthenticationHeaderValue("Bearer", "<token>");
request.Headers.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
request.Content = new StringContent("{\"name\":\"jon Doe\",\"extRelationId\":1,\"relationStrs\":[\"acct-1\",\"acct-1-legacy\"],\"enabled\":true}", Encoding.UTF8, "application/json");

var response = await client.SendAsync(request);
Console.WriteLine((int)response.StatusCode);
Console.WriteLine(await response.Content.ReadAsStringAsync());
require "net/http"
require "json"

uri = URI("https://cp.domain.com/api/v1/users/3")
request = Net::HTTP::Put.new(uri)
request["Authorization"] = "Bearer <token>"
request["Accept"] = "application/json"
request["Content-Type"] = "application/json"
request.body = "{\"name\":\"jon Doe\",\"extRelationId\":1,\"relationStrs\":[\"acct-1\",\"acct-1-legacy\"],\"enabled\":true}"

response = Net::HTTP.start(uri.host, uri.port, use_ssl: true) do |http|
  http.request(request)
end

puts response.code
puts JSON.pretty_generate(JSON.parse(response.body))
import Foundation

var request = URLRequest(url: URL(string: "https://cp.domain.com/api/v1/users/3")!)
request.httpMethod = "PUT"
request.setValue("Bearer <token>", forHTTPHeaderField: "Authorization")
request.setValue("application/json", forHTTPHeaderField: "Accept")
request.setValue("application/json", forHTTPHeaderField: "Content-Type")
request.httpBody = "{\"name\":\"jon Doe\",\"extRelationId\":1,\"relationStrs\":[\"acct-1\",\"acct-1-legacy\"],\"enabled\":true}".data(using: .utf8)

let task = URLSession.shared.dataTask(with: request) { data, response, error in
    guard let data = data, error == nil else { print(error ?? "request failed"); return }
    print((response as! HTTPURLResponse).statusCode)
    print(String(data: data, encoding: .utf8) ?? "")
}
task.resume()
// Cargo.toml: reqwest = { version = "0.12", features = ["blocking", "json"] }, serde_json = "1"
use reqwest::blocking::Client;

fn main() -> Result<(), Box<dyn std::error::Error>> {
    let client = Client::new();
    let response = client
        .request(reqwest::Method::PUT, "https://cp.domain.com/api/v1/users/3")
        .bearer_auth("<token>")
        .header("Accept", "application/json")
        .header("Content-Type", "application/json")
        .body(r#"{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}"#)
        .send()?;

    println!("{}", response.status());
    let json: serde_json::Value = response.json()?;
    println!("{}", serde_json::to_string_pretty(&json)?);
    Ok(())
}
// Cargo.toml: reqwest = { version = "0.12", features = ["json"] }, tokio = { version = "1", features = ["full"] }, serde_json = "1"
use reqwest::Client;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let client = Client::new();
    let response = client
        .request(reqwest::Method::PUT, "https://cp.domain.com/api/v1/users/3")
        .bearer_auth("<token>")
        .header("Accept", "application/json")
        .header("Content-Type", "application/json")
        .body(r#"{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}"#)
        .send()
        .await?;

    println!("{}", response.status());
    let json: serde_json::Value = response.json().await?;
    println!("{}", serde_json::to_string_pretty(&json)?);
    Ok(())
}
import okhttp3.MediaType.Companion.toMediaType
import okhttp3.OkHttpClient
import okhttp3.Request
import okhttp3.RequestBody.Companion.toRequestBody

fun main() {
    val client = OkHttpClient()
    val body = """{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}""".toRequestBody("application/json".toMediaType())
    val request = Request.Builder()
        .url("https://cp.domain.com/api/v1/users/3")
        .method("PUT", body)
        .addHeader("Authorization", "Bearer <token>")
        .addHeader("Accept", "application/json")
        .build()

    client.newCall(request).execute().use { response ->
        println(response.code)
        println(response.body?.string())
    }
}
// pubspec.yaml: http: ^1.2.0
import 'dart:convert';
import 'package:http/http.dart' as http;

Future<void> main() async {
  final request = http.Request('PUT', Uri.parse('https://cp.domain.com/api/v1/users/3'));
  request.headers['Authorization'] = 'Bearer <token>';
  request.headers['Accept'] = 'application/json';
  request.headers['Content-Type'] = 'application/json';
  request.body = r'''{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}''';

  final response = await http.Response.fromStream(await request.send());
  print(response.statusCode);
  print(const JsonEncoder.withIndent('  ').convert(jsonDecode(response.body)));
}
#include <stdio.h>
#include <curl/curl.h>

int main(void) {
    CURL *curl = curl_easy_init();
    if (!curl) return 1;

    struct curl_slist *headers = NULL;
    headers = curl_slist_append(headers, "Authorization: Bearer <token>");
    headers = curl_slist_append(headers, "Accept: application/json");
    headers = curl_slist_append(headers, "Content-Type: application/json");

    curl_easy_setopt(curl, CURLOPT_URL, "https://cp.domain.com/api/v1/users/3");
    curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "PUT");
    curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"name\":\"jon Doe\",\"extRelationId\":1,\"relationStrs\":[\"acct-1\",\"acct-1-legacy\"],\"enabled\":true}");

    CURLcode result = curl_easy_perform(curl);
    if (result != CURLE_OK) fprintf(stderr, "%s\n", curl_easy_strerror(result));

    curl_slist_free_all(headers);
    curl_easy_cleanup(curl);
    return result == CURLE_OK ? 0 : 1;
}
$headers = @{
    Authorization = "Bearer <token>"
    Accept        = "application/json"
}

$body = @'
{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}
'@

$response = Invoke-RestMethod -Uri "https://cp.domain.com/api/v1/users/3" -Method PUT -Headers $headers -ContentType "application/json" -Body $body
$response | ConvertTo-Json -Depth 10
PUT /api/v1/users/3 HTTP/1.1
Host: cp.domain.com
Authorization: Bearer <token>
Accept: application/json
Content-Type: application/json
Content-Length: 141

{
    "name": "jon Doe",
    "extRelationId": 1,
    "relationStrs": [
        "acct-1",
        "acct-1-legacy"
    ],
    "enabled": true
}

Responses

200

The user after the change.

#
application/json
object
dataUser#

A user account. password is only present in the response to creating a user.

User fields
idinteger#
adminboolean#
extRelationIdinteger#nullable
relationStrsarray[string]#

The relation strings the user is linked by, in the order they were added.

selfServiceinteger#

Self-service level for the user; disabled by default.

ValueMeaning
0Disabled
1Hourly
2Resource packs
3Hourly and resource packs
selfServiceHourlyGroupProfilesarray[any]#
selfServiceResourceGroupProfilesarray[any]#
selfServiceHourlyResourcePackinteger#nullable
namestring#
emailstring#
timezonestring#
suspendedboolean#
twoFactorAuthboolean#
createdstring <date-time>#
updatedstring <date-time>#
passwordstring#

Only returned when the user is created.

Example
{
    "data": {
        "id": 3,
        "admin": false,
        "extRelationId": 1,
        "relationStrs": [
            "acct-1"
        ],
        "selfService": 3,
        "selfServiceHourlyGroupProfiles": [],
        "selfServiceResourceGroupProfiles": [],
        "selfServiceHourlyResourcePack": null,
        "name": "jon Doe",
        "email": "jon@doe.com",
        "timezone": "Europe/London",
        "suspended": false,
        "twoFactorAuth": false,
        "created": "2025-01-20T12:48:20.000000Z",
        "updated": "2025-01-20T13:00:38.000000Z"
    }
}
401

The bearer token is missing, invalid, or expired. The response has no body.

#
No response body.
403

The token does not carry the permission.

#
application/json
msgstring#
Example
{
    "msg": "the API token does not have the necessary permissions to execute this action"
}
404

The user was not found.

#
application/json
msgstring#
Example
{
    "msg": "user not found"
}
409

The user is an administrator.

#
application/json
msgstring#
Example
{
    "msg": "admin modify forbidden"
}
422

A field is invalid, a link is already used by another user, or admin was sent.

#
application/json
errorsobject#
Example
{
    "errors": {
        "extRelationId": [
            "is already linked to another user"
        ]
    }
}
429

Too many requests. Either the token's requests per minute are used up (see the `X-RateL…

#
application/json

Too many requests. Either the token's requests per minute are used up (see the X-RateLimit-* headers) or the calling address has failed authentication 10 times in a minute (the body then includes retry_after_seconds). Retry-After gives the seconds to wait.

object
errorsarray[string]#
retry_after_secondsinteger#

Seconds to wait before retrying. Present on the failed-authentication limit only.

Response headers
Retry-Afterinteger

Seconds to wait before retrying.

X-RateLimit-Limitinteger

The token's requests per minute (token limit only).

X-RateLimit-Remaininginteger

Requests left in the current minute (token limit only).

X-RateLimit-Resetinteger

Unix timestamp at which the minute resets (token limit only).

Examples
{
    "errors": [
        "Too Many Requests"
    ]
}
{
    "errors": [
        "Too many authentication attempts. Try again later."
    ],
    "retry_after_seconds": 42
}